//	A1.5.- analog
//	Autores: Jess Mara Corres, Carlos Ruiz Zamarreo y Cndido Bariin
//	Pamplona, Agosto 2016

#include	<htc.h>
#include	"analog.h"


extern void set_adc_inputs(unsigned char analog){	// Selecciona las entradas analgicas
		ADCON1=(ADCON1&0xF0)|analog;
}
extern void setup_adc(unsigned char mode){	// Selecciona el modo de reloj
	if (mode==0x00){					// CAD apagado
		ADCON0=0x00;				
		ADCON1&=0x06;	// E/S digitales
	}
	else if (mode==0xC1){		// Reloj RC
		ADCON0=0xC1;		// con ajuste derecho
		ADCON1&=0xBF;
	}
	else{
		if(ADC_FREQ_DIV<=1){		// Fosc <= 1.25MHz
				ADCON0=0x01; 		// ADCS1=0, ADCS0=0, Canal 0, Mdulo encendido
				ADCON1&=0xBF; 	// ADFM=1(ajuste a la derecha), ADCS2=0
		}
		else if(ADC_FREQ_DIV<=2){		// Fosc <= 2.5MHz
				ADCON0=0x01;		// ADCS1=0, ADCS0=0, Canal 0, Mdulo encendido
				ADCON1|=0xC0;		// ADFM=1(ajuste a la derecha), ADCS2=1
		}
		else if(ADC_FREQ_DIV<=4){		// Fosc <= 5MHz
				ADCON0=0x41;		// ADCS1=0, ADCS0=1, Canal 0, Mdulo encendido
				ADCON1&=0xBF; 	// ADFM=1(ajuste a la derecha), ADCS2=0
		}
		else if(ADC_FREQ_DIV<=8){ 	// Fosc <= 10MHz
				ADCON0=0x41; ;	// ADCS1=0, ADCS0=1, Canal 0, Mdulo encendido
				ADCON1|=0xC0; 	// ADFM=1(ajuste a la derecha), ADCS2=1
		}
		else if(ADC_FREQ_DIV<=16){ 	// Fosc <= 20MHz
				ADCON0=0x81;		// ADCS1=1, ADCS0=0, Canal 0, Mdulo encendido
				ADCON1&=0xBF; 	// ADFM=1(ajuste a la derecha), ADCS2=0
		}
		else{					// Fosc <= 40MHz
				ADCON0=0x81;		// ADCS1=1, ADCS0=0, Canal 0, Mdulo encendido
				ADCON1|=0xC0;		// ADFM=1(ajuste a la derecha), ADCS2=1
		}
	}
}

extern void set_adc_channel(unsigned char channel){	// Selecciona el canal de conversin
// Cada vez que se cambia de canal es necesario esperar el tiempo de adquisicin (aprox 44us) para
// que se estabilice la tensin a la entrada del CAD antes de lanzar una conversin nueva.
	ADCON0 = (ADCON0&0xC7)| ((channel&0x07)<<3);
}

extern unsigned int read_adc(){				// Recoge el valor de la conversin
	while(GO)continue;
	return ((ADRESH<<2)+(ADRESL>>6));
}

extern void setup_cvref(unsigned char mode, float volt){
	if(mode&0x20) CVRCON=((int)((volt/CVRSRC)*24)&0x0F)|mode;

	else	CVRCON=((int)(((volt -(0.25*CVRSRC))/CVRSRC)*32)&0x0F)|mode;
}