//	A1.5.- analog
//	Autores: Jess Mara Corres, Carlos Ruiz Zamarreo y Cndido Bariin
//	Pamplona, Agosto 2016

// CONSTANTES, MACROS Y FUNCIONES PARA EL CONVERSOR ANALGICO DIGITAL

#define ADC_OFF			0x00
#define ALL_DIGITAL			0x06
#define ALL_ANALOG 			0x00
#define ALL_ANALOG_V 		0x01
#define ALL_ANALOG_V_V- 	0x08
#define AN0 			0x0E
#define AN0_V_V- 			0x0F
#define AN0_AN1_V 			0x05
#define AN0_AN1_V_V- 		0x0D
#define AN0_AN1_AN3 			0x04
#define AN0_AN4 			0x02
#define AN0_AN4_V 			0x03
#define AN0_AN4_V_V- 		0x0C
#define AN0_AN5 			0x09
#define AN0_AN5_V 			0x0A
#define AN0_AN5_V_V- 		0x0B
#define _XTAL_FREQ 4000000
#define ADC_CLK_RC 			0xC1
#define ADC_CLK_OSC 			0X01
#define ADC_FREQ_DIV		(float)(_XTAL_FREQ/1250000)
#define START_ADC_CONV		GO=1

extern void set_vref(unsigned char vref);
extern void set_adc_inputs(unsigned char analog);
extern void setup_adc(unsigned char mode);
extern void set_adc_channel(unsigned char channel);
extern unsigned int read_adc(void);

// CONSTANTES, MACROS Y FUNCIONES PARA EL COMPARADOR ANALGICO

#define CA_RESET 				0x00
#define CA_A0_A3_NC_NC_ON_A4		0x01
#define CA_A0_A3_A1_A2	 		0x02
#define CA_A0_A3_A1_A2_ON_A4_A5	0x03
#define CA_A0_A3_A1_A3			0x04
#define CA_A0_A3_A1_A3_ON_A4_A5	0x05
#define CA_A0_VR_A1_VR			0x06
#define CA_A3_VR_A2_VR			0x0E
#define CA_NC_NC_NC_NC_OFF		0x07
#define CA_C1INV				0x10
#define CA_C2INV				0x20

#define	SETUP_COMPARATOR(CONFIG_COMPARATOR) \
	CMCON=CONFIG_COMPARATOR;

// CONSTANTES, MACROS Y FUNCIONES PARA EL MDULO CVREF

#define CVRSRC 	4.416	
#define CVR_ON 	0x80
#define	CVR_OFF 	0x00
#define CVR_LOW 	0x20
#define CVR_HIGH 	0x00
#define CVR_OUT_ON 	0x40
#define CVR_OUT_OFF 	0x00
#define CVRR_0	0x00
#define CVRR_1	0x01
#define CVRR_2	0x02
#define CVRR_3	0x03
#define CVRR_4	0x04
#define CVRR_5	0x05
#define CVRR_6	0x06
#define CVRR_7	0x07
#define CVRR_8	0x08
#define CVRR_9	0x09
#define CVRR_10	0x0A
#define CVRR_11	0x0B
#define CVRR_12	0x0C
#define CVRR_13	0x0D
#define CVRR_14	0x0E
#define CVRR_15	0x0F

#define SET_CVREF(MODE)	CVRCON=MODE
extern void setup_cvref(unsigned char mode, float volt);